import httplib
from .lun_container import LUNContainer
from .system_object import CollectionSystemObject
from .defaults import has_defaults, GENERATE_NAME

class Cluster(CollectionSystemObject, LUNContainer):
    @classmethod
    @has_defaults
    def create(cls, system, name=GENERATE_NAME):
        return cls._create_from_post(system, dict(name=name))
    def add_host(self, host):
        self._api.post("hosts", {"id" : host.get_id()})
    def remove_host(self, host):
        self._api.delete("hosts/{0}".format(host.get_id()))
    def get_hosts(self):
        return [self._system.objects.Host(host["id"]) for host in self._api.get("hosts")]
    def purge(self):
        for lun in list(self.get_luns()):
            self.unmap_volume(lun=lun)
        super(Cluster, self).purge()

