from .physical_object import PhysicalObject
from infinibox_sysdefs import latest as sysdefs

SERVICE_CLUTSER_STATES = sysdefs.enums.service_clusters.states


class ServiceCluster(PhysicalObject):
    states = SERVICE_CLUTSER_STATES
    _base_api_path = "services/{0}"

    def __init__(self, system, info):
        super(ServiceCluster, self).__init__(system)
        self._name = info['name']

    def get_name(self):
        return self._name

    def get_state(self):
        return self._get_underlying_object()['cluster_state']

    def _get_api_path(self, cmd="", *args, **kwargs):
        return super(ServiceCluster, self)._get_api_path(cmd, self.get_name(), *args, **kwargs)

    def start(self, node=None):
        data = {'node_id': node.get_id()} if node else None
        self._system.api.post(self._get_api_path('/start'), data=data)

    def stop(self, node=None):
        data = {'node_id': node.get_id()} if node else None
        self._system.api.post(self._get_api_path('/stop'), data=data)
